/*
Il programma gestisce una PILA come segue:  (Pila, LIFO, L'ultimo elemento inserito è il primo che esce)


i val
viene inserito val come prima elemento (head) della lista.

d k
viene cancellato il k-esimo (k > 0) elemento dalla lista
(la testa della lista si considera in posizione 1, primo elemento).

p val
viene stampato il contenuto della lista.

q val
il programma termina
(il valore val non e' usato in questo caso).

*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

/*
	Creo una lista subordinata. In questa lista devo inserire i comandi da tastiera. E solo dopo eseguo tutte le operazioni
	descritte prima

*/

/*
	Mi creo le strutture delle due liste:
	struct comando:
		contiene cmd che è il comando e val che 'è il valore da inserire
	struct lista
		contiene la struttura della lista vera e propria, e inf che è il valore da inserire
*/

	struct comando
	{
		char cmd[50];
		char val[100];
		struct comando *cmdnext;
	};

	struct lista
	{
		char inf[100];
		struct lista *infnext;
	};

/*
Creo la funzione per creare la lista dei comandi
*/
	struct comando *crea_comandi()
	{
		struct comando *testa_comando, *temp;
		int esci=2;
		int opzione=2;
int i=-1;
char c;		
testa_comando=(struct comando *)malloc(sizeof(struct comando));  // Creo una nuova struttura
		scanf("%s", &testa_comando->cmd);
		if (opzione=(strcmp((testa_comando->cmd),"push"))==0)
		{		
		while ((c=getchar() )!='\n')		
		testa_comando->val[i++]=c;
}
		testa_comando->val[i]='\0';		
		//scanf("%s", &testa_comando->val);
		temp=testa_comando;
		esci=(strcmp((testa_comando->cmd),"quit"));
		while (esci!=0)
		{
			// Creo la restante lista
			temp->cmdnext=(struct comando *)malloc(sizeof(struct comando));
			temp=temp->cmdnext;
			scanf("%s", &temp->cmd);
i=-1;
if (opzione=(strcmp((temp->cmd),"push"))==0)
		{		
		while ((c=getchar() )!='\n')		
		temp->val[i++]=c;
}
		temp->val[i]='\0';		
			esci=(strcmp((temp->cmd),"quit"));
		}

		temp->cmdnext=NULL;
		return (testa_comando);
	}

/*
Funzione di visualizzazione
*/

	visualizza_contatore(struct lista *p)
	{
	int contatore=0;
		while (p!=NULL)
		{
		contatore++;
		p=p->infnext;
		}
		printf("%d\n",contatore);
	}
	
/*
Funzione di ELIMINAZIONE
*/

	struct lista *elimina(struct lista *p, int ele)
	{
		int i=0;
		struct lista *p2, *p1=p;
		if (p!=NULL) 
		{
		if (ele==1)
		{
			p2=p;
			p=p->infnext;
			free(p2);
			return(p);
		}
		else
		{
			for(i=2; i<ele; i++)
				{
				p1=p1->infnext;
			}
			p2=p1->infnext;
			p1->infnext=p1->infnext->infnext;
			free(p2);
			return(p);

		}
		}
		if (p==NULL)
		return(p);

	}




/*
Creo la lista vera è propria stile PILA
*/

	struct lista *crea_lista(struct lista *p, char ele[100])
	{
	struct lista *temp;
	temp=(struct lista *)malloc(sizeof(struct lista));
	temp->infnext=p;
	p=temp;
	strcpy((p->inf), ele);
	return (p);
	}


	main()
	{
		char informazione[100]={'\0'};
		int i,k;
		int opzione=9;
		struct comando *listacmd;
		struct lista *testa_lista=NULL;
		listacmd=crea_comandi();
		printf("Matteo\nLa Bella\n27\n09\n1983\nmatteo.unive@flashnet.it\n");
		while (listacmd!=NULL)
	{
		if (opzione=(strcmp((listacmd->cmd),"push"))==0)
		{
			strcpy(informazione,(listacmd->val));
			testa_lista=crea_lista(testa_lista, informazione);
		}

		if (opzione=(strcmp((listacmd->cmd),"size"))==0)
		visualizza_contatore(testa_lista);

		if (opzione=(strcmp((listacmd->cmd),"pop"))==0)
		{
			k=1;
			if (testa_lista!=NULL)
			printf("%s\n",testa_lista->inf);
			testa_lista=elimina(testa_lista, k);

		}

		listacmd=listacmd->cmdnext;
	}

	}
